﻿/*Kullanıcıdan alınan 4 noktadan geçen kübik spline örneği
* 
* OPENGL KURULUMU YAPMADIYSANIZ FREEGLUT NUGET PAKETİNİ İNDİRİNİZ 
* ÖĞR. GÖR. UFUK ŞANVER
*
* BİLGİSAYAR GRAFİKLERİ ALANINA İLGİ DUYMAMI SAĞLAYAN PROF. DR. RIFAT YAZICI'YA TEŞEKKÜRLERİMLE
*
* OPENGL İÇİN REFERANS KAYNAK:
* SUMANTA GUHA. COMPUTER GRAPHICS THROUGH OPENGL, CRC, 4TH EDITION
*
* KÜBİK SPLINE İÇİN REFERANS KAYNAKLAR:
* 1- CHAPRA, CANALE. MÜHENDİSLER İÇİN SAYISAL YÖNTEMLER, LİTERATÜR YAYINLARI
* 2- DOÇ. DR. EYÜP SABRİ TÜRKER, ENGİN CAN. BİLGİSAYAR UYGULAMALI SAYISAL ANALİZ YÖNTEMLERİ, DEĞİŞİM YAYINLARI
*/


#include <iostream>
#include <cmath>
#include <GL/freeglut.h>

float ww = 100.0;
float wh = 100.0;
float xx[4] = { 100.0,200.0,300.0,400.0 };
float yy[4] = { 100.0,80.0,110.0,80.0 };

void KubikSpline(void)
{
	int ii = 0;
	int xsay = 0; // x yönü sayaç
	int xsayeski = 0;
	int ysayieski = 0;
	int ysayi = 0;
	float kirmizi = 153.0;;
	float yesil = 71.0;
	float mavi = 88.0;
	float ysay; //ilgili xsay değerine karşı düşen y koordinatının değeri
	float parca1 = 0.0;
	float parca2 = 0.0;
	float parca3 = 0.0;
	float parca4 = 0.0;
	float parca5 = 0.0;
	float parca6 = 0.0;
	float fdd[4] = { 0.0,0.0,0.0,0.0 };//f''(x)--> Kübik spline şartından dolayı f''(x0)=0 ve f''(x3)=0 olur

	float sonuc1 = (6 / (xx[2] - xx[1])) * (yy[2] - yy[1]) + (6 / (xx[1] - xx[0])) * (yy[0] - yy[1]);
	float sonuc2 = (6 / (xx[3] - xx[2])) * (yy[3] - yy[2]) + (6 / (xx[2] - xx[1])) * (yy[1] - yy[2]);
	float matris[2][2];
	/*x1 ve x2 için kübik spline eşitliğinden yararlanılarak iki bilinmeyenli iki denklem elde edilir
	  Bilinmeyenler f''(x1) ve f''(x2) dir.
	  Matrisin tersi alınarak ilgili işlemler yapılır ve bilinmeyenler hesaplanır
	*/
	matris[0][0] = 2 * (xx[2] - xx[0]);
	matris[0][1] = xx[2] - xx[1];
	matris[1][0] = xx[2] - xx[1];
	matris[1][1] = 2 * (xx[3] - xx[1]);
	float deter = matris[0][0] * matris[1][1] - matris[0][1] * matris[1][0];
	float tersmatris[2][2];
	tersmatris[0][0] = matris[1][1] / deter;
	tersmatris[0][1] = -1.0 * (matris[0][1] / deter);
	tersmatris[1][0] = -1.0 * (matris[1][0] / deter);
	tersmatris[1][1] = matris[0][0] / deter;

	fdd[1] = tersmatris[0][0] * sonuc1 + tersmatris[0][1] * sonuc2;//f''(x1)
	fdd[2] = tersmatris[1][0] * sonuc1 + tersmatris[1][1] * sonuc2;//f''(x2)
	printf(" f''(x1) = %f f''(x2)=%f", fdd[1], fdd[2]);

	kirmizi = 20.0;
	yesil = 192.0;
	mavi = 241.0;

	glClear(GL_COLOR_BUFFER_BIT);
	glColor3f(kirmizi / 255, yesil / 255, mavi / 255);
	glLineWidth(10.0);
	glBegin(GL_LINES);

	xsayeski = xx[0];
	ysayieski = yy[0];
	for (xsay = xx[0] + 1;xsay <= xx[3];xsay++) {

		if (xsay < xx[1]) {
			ii = 1;
		}
		else if (xsay < xx[2]) {
			ii = 2;
		}
		else {
			ii = 3;
		}

		//Karmaşık İşlemler Kodlanırken Görsel Kolaylık ve Hata Olmaması için parçalara bölünerek yaklaşılmıştır
		parca1 = (fdd[ii - 1] / (6 * (xx[ii] - xx[ii - 1]))) * pow((xx[ii] - xsay), 3);
		parca2 = (fdd[ii] / (6 * (xx[ii] - xx[ii - 1]))) * pow((xsay - xx[ii - 1]), 3);
		parca3 = (((yy[ii - 1]) / (xx[ii] - xx[ii - 1])) - ((fdd[ii - 1] / 6.0) * (xx[ii] - xx[ii - 1]))) * (xx[ii] - xsay);
		parca5 = (yy[ii] / (xx[ii] - xx[ii - 1]));
		parca6 = ((fdd[ii] / 6.0) * (xx[ii] - xx[ii - 1]));
		parca4 = (parca5 - parca6) * (xsay - xx[ii - 1]);
		ysay = parca1 + parca2 + parca3 + parca4;
		ysayi = floor(ysay);//Piksel değerini belirlemek amacıyla yuvarlanmıştır
		printf("\n x= %d ysayi=%d", xsay, ysayi);
		glVertex2d(xsayeski, ysayieski);
		glVertex2d(xsay, ysayi);
		xsayeski = xsay;
		ysayieski = ysayi;

	}
	glEnd();
	glFlush();
}

void baslangic()
{
	float kirmizi = 164.0;;
	float yesil = 29.0;
	float mavi = 52.0;
	glClearColor(kirmizi / 255, yesil / 255, mavi / 255, 0.0);
}


void penceredegisimineadaptet(int genislik, int yukseklik)
{
	glViewport(0, 0, genislik, yukseklik);
	ww = genislik;
	wh = yukseklik;
	printf("\n genislik=%u  yukseklik=%u", genislik, yukseklik);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0.0, ww, 0.0, wh, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}



int main(int argc, char** argv)
{
	for (short sayac = 0;sayac < 4;sayac++) {
		printf("\n x[%d] girin=", sayac);
		scanf_s("%f", &xx[sayac]);
		printf("y[%d] girin=", sayac);//y(i)--> f(Xi)
		scanf_s("%f", &yy[sayac]);
	}
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGBA);
	glutInitWindowSize(600, 600);//Ekran büyüklüğü
	glutInitWindowPosition(150, 150);//Pencerenin başlangıç konumu
	glutCreateWindow("KUBIK SPLINE UYGULAMASI");
	glutDisplayFunc(KubikSpline);
	glutReshapeFunc(penceredegisimineadaptet);
	baslangic();

	glutMainLoop();
}
